3 Upgrading and Preparing Your Oracle Databases for 12c

It is important to understand the database requirements for upgrade. You may need to upgrade your database to a supported version prior to upgrade.

The following sections describe some of the tasks associated with preparing your Oracle database for an upgrade to 12c (12.2.1.3.0). For more information, see Preparing to Upgrade an Oracle Database in the Oracle Database Upgrade Guide.

Note:

When upgrading to 12c (12.2.1.3.0) your existing database must be used for the upgrade. Do not create a new database.

About Finding the Latest Information About Upgrading Oracle Database

Review and understand the database requirements before the upgrade. Many Oracle Fusion Middleware products require database schemas prior to domain configuration.

Through its support website, Oracle provides late-breaking updates, discussions, and best practices about pre-upgrade requirements, upgrade processes, post-upgrade, compatibility, and interoperability.

Oracle also strongly recommends that you download and run the Pre-Upgrade Information Tool, which is available on My Oracle Support.

  • My Oracle Support:

    http://support.oracle.com

    You can search in the library, or search on My Oracle Support for keywords, such as "Database Upgrade"

  • Oracle Database Pre-Upgrade Utility (Document ID 884522.1) at My Oracle Support

  • Oracle Database 12c Release 2 Upgrade Companion (Document ID 1670757.1) at My Oracle Support

To find a certified database for your operating system, see the certification document for your release on the Oracle Fusion Middleware Supported System Configurations page.

To make sure your database is properly configured for schema creation, see "Verifying Requirements for Oracle Repository Creation Utility" in the Oracle Fusion Middleware System Requirements and Specifications document.

Note:

Only a certified database can be used for the standard installation topology. Do not attempt an upgrade if the database hosting the repository schemas is not supported.

Applying the Latest Patch Set Updates and Any Required Patches

It is important to understand the latest and recommended patches required to avoid any issues during the upgrade.

Potential interoperability and upgrade issues can be avoided by making sure you have applied the latest patch sets, and that you have reviewed the list of recommended patches that are designed to help you avoid any problems during upgrade.

For more information, see the Upgrade chapter of the Release Notes for your platform. For example, if you are using a Linux operating system, refer to Patches Required to Address Specific Upgrade and Compatibility Requirementsin the Oracle® Application Server Release Notes .

For additional information about database patching requirements, see Review System Requirements and Specificationsin the Planning an Installation of Oracle Fusion Middleware.

Backing Up the Schema Version Registry Table

Your system backup must include the SYSTEM.SCHEMA_VERSION_REGISTRY$ table or the FMWREGISTRY.SCHEMA_VERSION_REGISTRY$ table.

Each Fusion Middleware schema has a row in the SYSTEM.SCHEMA_VERSION_REGISTRY$ table. If you run the Upgrade Assistant to update an existing schema and it does not succeed, you must restore the original schema before you can try again. Before you run the Upgrade Assistant, make sure you back up your existing database schemas and the schema version registry.

Note:

Before you upgrade a schema using the Upgrade Assistant, you must perform a complete database backup. During the upgrade, you are required to acknowledge that backups have been performed.

Verifying Your Database Objects Are Ready for Upgrade

Before starting an upgrade, you should make sure that your supported database has no invalid objects and that the schemas you want to upgrade are at versions that are supported for upgrade.

It is important to know whether or not your schemas and are ready for upgrade because schemas are upgraded in place, which means that the existing database schemas are upgraded.

Verify Schema Versions

When the schemas are created in your database, RCU creates and maintains a table called schema_version_registry. This table contains schema information such as version number, component name and ID, date of creation and modification, and custom prefix.

Before you run the Upgrade Assistant, make sure that you have verified that the schemas you want to upgrade are supported for an upgrade to this version of Oracle Fusion Middleware.

If you are using an Oracle database, connect to the database as a user having Oracle DBA privileges, and run the following from SQL*Plus to get the current version numbers:

SET LINE 120
COLUMN MRC_NAME FORMAT A14
COLUMN COMP_ID FORMAT A20
COLUMN VERSION FORMAT A12
COLUMN STATUS FORMAT A9
COLUMN UPGRADED FORMAT A8
SELECT MRC_NAME, COMP_ID, OWNER, VERSION, STATUS, UPGRADED FROM SCHEMA_VERSION_REGISTRY ORDER BY MRC_NAME, COMP_ID ;

If the number in the "VERSION" is at 11.1.1.7.0 or higher, and the STATUS column is 'VALID', then the schema is supported for upgrade.

If an upgrade is not needed for a schema, the schema_version_registry table retains the schemas at their pre-upgrade version after the upgrade.

Check for Invalid Database Objects

If you are using an Oracle database, you should recompile database objects before running the Upgrade Assistant to check for invalid objects before the upgrade. Connect to the database as SYS and run the following from SQL*Plus:

SELECT owner, object_name FROM all_objects WHERE status='INVALID';

Take note of any invalid objects and run the following query for more information. The existence of invalid database objects may prevent the upgrade from completing successfully.

oracle_home/software/rdbms/admin/utlrp.sql

To recompile just the objects that belong to a single Oracle Fusion Middleware schema, you can use the Oracle Database stored procedure dbms_utility.compile_schema as shown in the example below:

SQL> execute
dbms_utility.compile_schema('1213_IAU');
PL/SQL procedure successfully completed 

Note:

These procedures should be used again after running the Upgrade Assistant for verification.